-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core, ui;

package body attribute is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	sprite : array (enumeration) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	procedure configure is
		structure : ui.structure;
	begin
		core.echo (core.comment, "Configuring attribute components...");
		--
		structure.title  := "Attribute Menu          ";
		structure.toggle := core.signal_a;
		structure.show   := false;
		structure.center := false;
		structure.resize := true;
		structure.x      := 60;
		structure.y      := 80;
		structure.gui_n  := count;
		--
		ui.add_structure (structure);
		--
		for index in enumeration loop
			sprite (index) := core.import_sprite ("./sprite/attribute/" & core.lowercase (enumeration'image (index)) & ".png", 1, 1);
			--
			ui.add_structure_button (sprite (index), trait (index).name, trait (index).text);
		end loop;
	end configure;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end attribute;
