-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core;

package attribute is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		offense,                defense,                wisdom,                 stamina,                speed,                  reach
	);

                                             ------------------------------------------------------------------------------------------

	type information is record
		name : core.short_string;
		base : natural;
		text : core.long_string;
	end record;

	type points is array (enumeration) of natural;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("Offense                 ", 0, "Offense attribute determines your damage modifier when attacking.       "),
		("Defense                 ", 0, "D-FENS attribute determines how much damage your reflect and receive.   "),
		("Wisdom                  ", 0, "Wisdom attribute determines how much mana your chad has.                "),
		("Stamina                 ", 0, "Stamina attribute determines how fast you recover from being wounded.   "),
		("Speed                   ", 0, "Speed attribute determines how far you can walk per turn.               "),
		("Reach                   ", 0, "Reach attribute determines your range modifier when shooting or casting.")
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end attribute;
