-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core;

package resource is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		gold,                   wood,                   stone,                  metal,                  leather,                gem
	);

                                             ------------------------------------------------------------------------------------------

	type information is record
		name : core.short_string;
		base : natural;
		text : core.long_string;
	end record;

	type points is array (enumeration) of natural;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("Gold                    ", 0, "Gold is precious yellowish shiny metal, valued since ancient times.     "),
		("Wood                    ", 0, "Wood is just bundle of lignin and cellulose, nothing more.              "),
		("Stone                   ", 0, "Stone is essential building block for most constructions in this world. "),
		("Metal                   ", 0, "Metal as a resource is mixture of commonly found metalic elements.      "),
		("Leather                 ", 0, "Leather is general purpose resource, used for armours and decorations.  "),
		("Gem                     ", 0, "Gem as a resource is same as metal, just mixture of various gems.       ")
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end resource;
