-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core, ui;

package body skill is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	sprite : array (enumeration) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	procedure configure is
		structure : ui.structure;
	begin
		core.echo (core.comment, "Configuring skill components...");
		--
		structure.title  := "Skill Menu              ";
		structure.toggle := core.signal_s;
		structure.show   := false;
		structure.center := true;
		structure.resize := true;
		structure.x      := 80;
		structure.y      := (core.window_height - 320) / 2;
		structure.gui_n  := count + 1;
		--
		ui.add_structure (structure);
		--
		for index in enumeration loop
			sprite (index) := core.import_sprite ("./sprite/skill/" & core.lowercase (enumeration'image (index)) & ".png", 1, 1);
			--
			if enumeration'pos (index) = 9 then
				ui.add_structure_orient;
			end if;
			--
			ui.add_structure_button (sprite (index), trait (index).name, trait (index).text);
		end loop;
	end configure;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end skill;
